﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Type T_Point(ID As Int,X As Int, Y As Int, Z As Int,Color As Int, AngleZX As Double, AngleYX As Double, AngleYZ As Double, RadialZX As Float,RadialYX As Float, RadialYZ As Float)
	Type T_Line(P1 As T_Point, P2 As T_Point)
	Type T_Image(BitmapCreator As BitmapCreator,P_TopLeft As T_Point, P_TopRight As T_Point, P_DownLeft As T_Point, P_DownRight As T_Point)
	Type T_Line2D(X As Float, Y As Float, Z As Float, Color As Int,X2 As Float, Y2 As Float, Z2 As Float, Color2 As Int)
	
	Private xui As XUI
	Private LineList As List
	Private PolygonList As List
	Private ImageList As List
			
	Private Const Dp As Float = 100dip/100
	Private Const Frac As Float = 300
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	LineList.Initialize
	PolygonList.Initialize
	ImageList.Initialize
End Sub

Public Sub ClearLinesList
	LineList.Clear
End Sub

Public Sub CLearPolygonList
	PolygonList.Clear
End Sub

Public Sub CLearImageList
	ImageList.Clear
End Sub

#Region Add

public Sub AddLine(X1 As Int, Y1 As Int, Z1 As Int,X2 As Int, Y2 As Int, Z2 As Int, Color As Int) As Vector3D
	Dim NewLines As T_Line
	NewLines.Initialize
	NewLines.P1.Initialize
	NewLines.P2.Initialize
	
	NewLines.P1.X=X1
	NewLines.P1.y=Y1
	NewLines.P1.z=Z1
	NewLines.P2.X=X2
	NewLines.P2.Y=Y2
	NewLines.P2.Z=Z2
	NewLines.p1.Color=Color
	NewLines.p2.Color=Color

	NewLines.P1.AngleYX=ATan2D(Y1,X1)
	NewLines.P1.RadialYX=Sqrt(Power(Y1,2)+Power(X1,2))
	NewLines.P1.AngleYZ=ATan2D(Y1,Z1)
	NewLines.P1.RadialYZ=Sqrt(Power(Y1,2)+Power(Z1,2))
	NewLines.P1.AngleZX=ATan2D(Z1,X1)
	NewLines.P1.RadialZX=Sqrt(Power(Z1,2)+Power(X1,2))
	
	NewLines.P2.AngleYX=ATan2D(Y2,X2)
	NewLines.P2.RadialYX=Sqrt(Power(Y2,2)+Power(X2,2))
	NewLines.P2.AngleYZ=ATan2D(Y2,Z2)
	NewLines.P2.RadialYZ=Sqrt(Power(Y2,2)+Power(Z2,2))
	NewLines.P2.AngleZX=ATan2D(Z2,X2)
	NewLines.P2.RadialZX=Sqrt(Power(Z2,2)+Power(X2,2))

	LineList.Add(NewLines)
	
	Return Me
End Sub

public Sub AddLine2(NewLinea As T_Line) As Vector3D
	NewLinea.P1.AngleYX=ATan2D(NewLinea.P1.Y,NewLinea.P1.X)
	NewLinea.P1.RadialYX=Sqrt(Power(NewLinea.P1.Y,2)+Power(NewLinea.P1.X,2))
	NewLinea.P1.AngleYZ=ATan2D(NewLinea.P1.Y,NewLinea.P1.Z)
	NewLinea.P1.RadialYz=Sqrt(Power(NewLinea.P1.Y,2)+Power(NewLinea.P1.Z,2))
	NewLinea.P1.AngleZX=ATan2D(NewLinea.P1.Z,NewLinea.P1.X)
	NewLinea.P1.RadialZX=Sqrt(Power(NewLinea.P1.Z,2)+Power(NewLinea.P1.X,2))
	
	NewLinea.P2.AngleYX=ATan2D(NewLinea.P2.Y,NewLinea.P2.X)
	NewLinea.P2.RadialYX=Sqrt(Power(NewLinea.P2.Y,2)+Power(NewLinea.P2.X,2))
	NewLinea.P2.AngleYZ=ATan2D(NewLinea.P2.Y,NewLinea.P2.Z)
	NewLinea.P2.RadialYz=Sqrt(Power(NewLinea.P2.Y,2)+Power(NewLinea.P2.Z,2))
	NewLinea.P2.AngleZX=ATan2D(NewLinea.P2.Z,NewLinea.P2.X)
	NewLinea.P2.RadialZX=Sqrt(Power(NewLinea.P2.Z,2)+Power(NewLinea.P2.X,2))

	LineList.Add(NewLinea)
	
	Return Me
End Sub

public Sub AddRec(X1 As Int, Y1 As Int, Z1 As Int,X2 As Int, Y2 As Int, Z2 As Int, Color As Int)
	AddLine(X1,Y1,Z1,X2,Y1,(Z1+Z2)/2,Color)
	AddLine(X2,Y1,(Z1+Z2)/2,X2,Y2,Z2,Color)
	AddLine(X1,Y2,(Z1+Z2)/2,X2,Y2,Z2,Color)
	AddLine(X1,Y1,Z1,X1,Y2,(Z1+Z2)/2,Color)
End Sub

Public Sub AddCircleZ(X As Int, Y As Int, Z As Int, R As Int, Color As Int) As Vector3D
	For i=1 To 720 
		Dim X1 As Int = r * CosD(i/2)
		Dim Y1 As Int = r * SinD(i/2)
		Dim X2 As Int = r * CosD((i-1)/2)
		Dim Y2 As Int = r * SinD((i-1)/2)
		AddLine(X1,Y1,Z,X2,Y2,z,Color)
	Next
	
	Return Me
End Sub

Public Sub AddCircleX(X As Int, Y As Int, Z As Int, R As Int, Color As Int) As Vector3D
	For i=1 To 720 
		Dim z1 As Int = r * CosD(i/2)
		Dim Y1 As Int = r * SinD(i/2)
		Dim z2 As Int = r * CosD((i-1)/2)
		Dim Y2 As Int = r * SinD((i-1)/2)
		AddLine(x,Y1,z1,X,Y2,z2,Color)
	Next
	
	Return Me
End Sub

Public Sub AddCircleY(X As Int, Y As Int, Z As Int, R As Int, Color As Int) As Vector3D
	For i=1 To 720
		Dim X1 As Int = r * CosD(i/2)
		Dim Z1 As Int = r * SinD(i/2)
		Dim x2 As Int = r * CosD((i-1)/2)
		Dim z2 As Int = r * SinD((i-1)/2)
		AddLine(X1,Y,Z1,x2,Y,z2,Color)
	Next
	
	Return Me
End Sub

Public Sub AddPolygon(ID As Int, X As Int,Y As Int,Z As Int, Color As Int) As Vector3D
	Dim P As T_Point
	P.Initialize
	
	P.ID=ID
	P.X=X
	P.Y=y
	P.Z=Z
	P.Color=Color
	
	P.AngleYX=ATan2D(P.Y,P.X)
	P.RadialYX=Sqrt(Power(p.Y,2)+Power(p.X,2))
	P.AngleYZ=ATan2D(P.Y,P.Z)
	P.radialYZ=Sqrt(Power(P.Y,2)+Power(P.Z,2))
	P.AngleZX=ATan2D(P.Z,P.X)
	P.RadialZX=Sqrt(Power(P.Z,2)+Power(P.X,2))
	PolygonList.Add(P)
	
	Return Me
End Sub

Public Sub AddImage(Image As B4XBitmap,P_TopLeft As T_Point, P_TopRight As T_Point, P_DownLeft As T_Point, P_DownRight As T_Point) As Vector3D
	Dim NewImage As T_Image
	Dim Bmc As BitmapCreator
	Bmc.Initialize(Image.Width,Image.Height)
	Bmc.CopyPixelsFromBitmap(Image)
	
	NewImage.Initialize
	NewImage.BitmapCreator=Bmc

	NewImage.P_TopLeft=P_TopLeft
	NewImage.P_TopRight=P_TopRight
	NewImage.P_DownLeft=P_DownLeft
	NewImage.P_DownRight=P_DownRight
	
	ImageList.Add(NewImage)
	
	Return Me
End Sub

#End Region

#region method

public Sub TraslationLine(X As Int,Y As Int, Z As Int) As Vector3D
	Dim NewLine3d As Vector3D
	
	NewLine3d.Initialize
	For I=0 To LineList.size-1
		Dim Line As T_Line = LineList.Get(I)
		
		Dim NLine As T_Line
		NLine.Initialize
		NLine.P1.Initialize
		NLine.P2.Initialize
		
		NLine.P1.X=Line.P1.X+X
		NLine.P1.y=Line.P1.y+Y
		NLine.P1.z=Line.P1.z+Z
		NLine.P1.Color=Line.P1.Color
		NLine.P2.X=Line.P2.X+X
		NLine.P2.Y=Line.P2.Y+Y
		NLine.P2.Z=Line.P2.Z
		NLine.P2.Color=Line.P2.Color
		
		NewLine3d.AddLine2(NLine)
	Next
	
	Return NewLine3d
End Sub

Public Sub CoordinateToPoint(ID As Int,X As Int,Y As Int, Z As Int, Color As Int) As T_Point
	Dim P As T_Point
	P.Initialize
	
	P.ID=ID
	P.X=X
	P.Y=y
	P.Z=Z
	P.Color=Color
	
	P.AngleYX=ATan2D(P.Y,P.X)
	P.RadialYX=Sqrt(Power(p.Y,2)+Power(p.X,2))
	P.AngleYZ=ATan2D(P.Y,P.Z)
	P.radialYZ=Sqrt(Power(P.Y,2)+Power(P.Z,2))
	P.AngleZX=ATan2D(P.Z,P.X)
	P.RadialZX=Sqrt(Power(P.Z,2)+Power(P.X,2))
	
	Return P
End Sub

Public Sub getLines(Index As Int) As T_Line
	Dim Lines As T_Line
	Lines=LineList.Get(Index)
	Return Lines
End Sub

Public Sub getLinesCount As Int	
	Return LineList.Size
End Sub

Public Sub getPoint(Index As Int) As T_Point
	Dim Point As T_Point
	Point=PolygonList.Get(Index)
	Return Point
End Sub

Public Sub getPointCount As Int	
	Return PolygonList.Size
End Sub

Public Sub getImage(Index As Int) As T_Image
	Dim Image As T_Image
	Image=ImageList.Get(Index)
	Return Image
End Sub

Public Sub getImageCount As Int	
	Return ImageList.Size
End Sub

#End Region

#Region Render

public Sub RenderToView(V As B4XView, StrokeWidth As Int)
	Dim Can As B4XCanvas
	Can.Initialize(V)
	Can.DrawCircle(V.Width/2,V.Height/2,Max(V.Width,V.Height),xui.Color_Transparent,True,1)
	
	Dim Linea As T_Line2D
	
	For i=0 To LineList.Size-1
		Linea=RenderLines(I)
		Can.DrawLine(Linea.X+V.Width/2 , _
		Linea.y+V.Height/2, _
		Linea.X2+V.Width/2, _
		Linea.y2+V.Height/2, _
		Linea.Color, StrokeWidth)
	Next
	
	
	If PolygonList.Size>0 Then
		Dim Path As B4XPath
		Dim Point As T_Point
		PolygonList.SortType("ID",True)
		Dim ID As Int = -1
						
		For i=0 To PolygonList.Size-1
			Dim P As T_Point = PolygonList.Get(i)
		
			If P.ID<>ID Then 
				If i>0  Then Can.DrawPath(Path,Point.Color,True,StrokeWidth)
				Point=RenderPoint(P)
				Path.Initialize(Point.X+V.Width/2,Point.Y+V.Height/2)
				ID=P.ID
			Else
				Point=RenderPoint(P)
				Path.LineTo(Point.X+V.Width/2,Point.Y+V.Height/2)
			End If
		Next
		Can.DrawPath(Path,Point.Color,True,StrokeWidth)
	End If
	
	If ImageList.Size>0 Then
		'Dim Path As B4XPath
		Dim Point,Point2,Point3,Point4 As T_Point
										
		For i=0 To ImageList.Size-1
			Dim Im As T_Image = ImageList.Get(i)
			
							
			Point=RenderPoint(Im.P_TopLeft)
			'Path.Initialize(Point.X+V.Width/2,Point.Y+V.Height/2)
			Point2=RenderPoint(Im.P_TopRight)
			'Path.LineTo(Point2.X+V.Width/2,Point2.Y+V.Height/2)
			Point3=RenderPoint(Im.P_DownRight)
			'Path.LineTo(Point3.X+V.Width/2,Point3.Y+V.Height/2)
			Point4=RenderPoint(Im.P_DownLeft)
			'Path.LineTo(Point4.X+V.Width/2,Point4.Y+V.Height/2)
			
			Trapezio(Im.BitmapCreator,Can,V.Width/2,V.Height/2,Point,Point2,Point4,Point3)
		Next
		
	End If
	
	Can.Invalidate
	Can.Release
End Sub

Private Sub RenderLines(i As Int) As T_Line2D
	Dim Ln As T_Line = LineList.Get(i)
	Dim L2 As T_Line2D
	Dim Fatt As Float
	L2.Initialize
		
	L2.z=Ln.P1.Z
	Fatt=Max(1+L2.z/Frac,0)
	L2.x=Ln.P1.RadialYX*CosD(Ln.P1.AngleYX)*Dp * Fatt
	L2.y=Ln.P1.RadialYX*SinD(Ln.P1.AngleYX)*Dp *Fatt

	L2.Z2=Ln.P2.Z
	Fatt=Max(1+L2.z2/Frac,0)
	L2.x2=Ln.P2.RadialYX*CosD(Ln.P2.AngleYX)*Dp * Fatt
	L2.y2=Ln.P2.RadialYX*SinD(Ln.P2.AngleYX)*Dp * Fatt
		
	L2.Color=TraspColor(Ln.P1.Color,(L2.Z+L2.Z2)/2)
	Return L2
End Sub

Private Sub RenderPoint(P As T_Point) As T_Point
	Dim L2 As T_Point
	Dim Fatt As Float
	L2.Initialize
		
	L2.z=p.z
	Fatt=Max(1+L2.z/Frac,0)
	L2.x=p.RadialYX*CosD(p.AngleYX)*Dp * Fatt
	L2.y=p.radialYX*SinD(p.AngleYX)*Dp *Fatt

		
	L2.Color=TraspColor(P.Color,L2.Z)
	Return L2
End Sub

Private Sub TraspColor (Clr As Int, Z As Int) As Int
	Dim Alfa As Int = 127+z/2
	Dim a,r,g,b As Int 'ignore
	a = Bit.And(0xff, Bit.ShiftRight(Clr, 24))
	r = Bit.And(0xff, Bit.ShiftRight(Clr, 16))
	g =  Bit.And(0xff, Bit.ShiftRight(Clr, 8))
	b =  Bit.And(0xff, Clr)
	Alfa=Min(Max(Alfa,0),255)
	Return xui.Color_ARGB(Alfa,r,g,b)
End Sub

Public Sub RotateZ(Degree As Int) As Vector3D
	Dim NewLine3d As Vector3D
	'Line
	NewLine3d.Initialize
	For I=0 To LineList.size-1
		Dim Line As T_Line = LineList.Get(I)
			
		Dim NLine As T_Line
		NLine.Initialize
		
		NLine.P1.X=Line.P1.RadialYX*CosD((360+Line.P1.AngleYX+Degree) Mod 360)
		NLine.P1.Y=Line.P1.RadialYX*SinD((360+Line.P1.AngleYX+Degree) Mod 360)
		NLine.P1.Z=Line.P1.Z
		NLine.P1.Color=Line.P1.Color
		NLine.P2.X=Line.P2.RadialYX*CosD((360+Line.P2.AngleYX+Degree) Mod 360)
		NLine.P2.y=Line.P2.RadialYX*SinD((360+Line.P2.AngleYX+Degree) Mod 360)
		NLine.P2.Z=Line.P2.Z
		NLine.P2.Color=Line.P2.Color
		
		NewLine3d.AddLine2(NLine)
	Next
	'Polygon
	For i=0 To PolygonList.Size-1
		Dim Pol As T_Point = PolygonList.Get(I)
		NewLine3d.AddPolygon(Pol.ID,Pol.RadialYX*CosD((360+Pol.ANgleYX+Degree) Mod 360), Pol.RadialYX*SinD((360+Pol.ANgleYX+Degree) Mod 360),Pol.Z,Pol.Color)
	Next
	' Image
	For i=0 To ImageList.Size-1
		Dim Im As T_Image = ImageList.Get(I)
		Dim P_TopLeft,P_TopRight,P_DownLeft,P_DownRight As T_Point
						
		P_TopLeft=CoordinateToPoint(-1,Im.P_TopLeft.RadialYX*CosD((360+Im.P_TopLeft.AngleYX+Degree) Mod 360),Im.P_TopLeft.RadialYX*SinD((360+Im.P_TopLeft.AngleYX+Degree) Mod 360),Im.P_TopLeft.z,0)
		P_TopRight=CoordinateToPoint(-1,Im.P_TopRight.RadialYX*CosD((360+Im.P_TopRight.AngleYX+Degree) Mod 360),Im.P_TopRight.RadialYX*SinD((360+Im.P_TopRight.AngleYX+Degree) Mod 360),Im.P_TopRight.z,0)
		P_DownLeft=CoordinateToPoint(-1,Im.P_DownLeft.RadialYX*CosD((360+Im.P_DownLeft.AngleYX+Degree) Mod 360),Im.P_DownLeft.RadialYX*SinD((360+Im.P_DownLeft.AngleYX+Degree) Mod 360),Im.P_DownLeft.z,0)
		P_DownRight=CoordinateToPoint(-1,Im.P_DownRight.RadialYX*CosD((360+Im.P_DownRight.AngleYX+Degree) Mod 360),Im.P_DownRight.RadialYX*SinD((360+Im.P_DownRight.AngleYX+Degree) Mod 360),Im.P_DownRight.z,0)
		NewLine3d.AddImage(Im.BitmapCreator.Bitmap,P_TopLeft,P_TopRight,P_DownLeft,P_DownRight)
	Next
	
	Return NewLine3d
End Sub

Public Sub RotateY(Degree As Int) As Vector3D
	Dim NewLine3d As Vector3D
	'Line
	NewLine3d.Initialize
	For I=0 To LineList.size-1
		Dim Line As T_Line = LineList.Get(I)
		
		Dim NLine As T_Line
		NLine.Initialize
		
		NLine.P1.X=Line.P1.RadialZX*CosD((360+Line.P1.AngleZX+Degree) Mod 360)
		NLine.P1.Y=Line.P1.Y
		NLine.P1.Z=Line.P1.RadialZX*SinD((360+Line.P1.AngleZX+Degree) Mod 360)
		NLine.P1.Color=Line.P1.Color
		
		NLine.P2.X=Line.P2.RadialZX*CosD((360+Line.P2.AngleZX+Degree) Mod 360)
		NLine.P2.Y=Line.P2.Y
		NLine.P2.z=Line.P2.RadialZX*SinD((360+Line.P2.AngleZX+Degree) Mod 360)
		NLine.P2.Color=Line.P2.Color
		
		NewLine3d.AddLine2(NLine)
	Next
	'Polygon
	For i=0 To PolygonList.Size-1
		Dim Pol As T_Point = PolygonList.Get(I)
		NewLine3d.AddPolygon(Pol.ID,Pol.RadialzX*CosD((360+Pol.ANglezX+Degree) Mod 360), Pol.Y,Pol.RadialzX*SinD((360+Pol.ANglezX+Degree) Mod 360),Pol.Color)
	Next
	' Image
	For i=0 To ImageList.Size-1
		Dim Im As T_Image = ImageList.Get(I)
		Dim P_TopLeft,P_TopRight,P_DownLeft,P_DownRight As T_Point
						
		P_TopLeft=CoordinateToPoint(-1,Im.P_TopLeft.RadialzX*CosD((360+Im.P_TopLeft.ANglezX+Degree) Mod 360),Im.P_TopLeft.Y,Im.P_TopLeft.RadialZX*SinD((360+Im.P_TopLeft.AngleZX+Degree) Mod 360),0)
		P_TopRight=CoordinateToPoint(-1,Im.P_TopRight.RadialzX*CosD((360+Im.P_Topright.ANglezX+Degree) Mod 360),Im.P_TopRight.Y,Im.P_TopRight.RadialzX*SinD((360+Im.P_TopRight.ANglezX+Degree) Mod 360),0)
		P_DownLeft=CoordinateToPoint(-1,Im.P_DownLeft.RadialzX*CosD((360+Im.P_DownLeft.ANglezX+Degree) Mod 360),Im.P_DownLeft.Y,Im.P_DownLeft.RadialzX*SinD((360+Im.P_DownLeft.ANglezX+Degree) Mod 360),0)
		P_DownRight=CoordinateToPoint(-1,Im.P_DownRight.RadialzX*CosD((360+Im.P_Downright.ANglezX+Degree) Mod 360),Im.P_DownRight.Y,Im.P_DownRight.RadialZX*SinD((360+Im.P_DownRight.AngleZX+Degree) Mod 360),0)
		NewLine3d.AddImage(Im.BitmapCreator.Bitmap,P_TopLeft,P_TopRight,P_DownLeft,P_DownRight)
	Next
	
	Return NewLine3d
End Sub

Public Sub RotateX(Degree As Int) As Vector3D
	Dim NewLine3d As Vector3D
	'Line
	NewLine3d.Initialize
	For I=0 To LineList.size-1
		Dim Line As T_Line = LineList.Get(I)
				
		Dim NLine As T_Line
		NLine.Initialize
		
		NLine.P1.X=Line.P1.X
		NLine.P1.y=Line.P1.RadialYZ*SinD((360+Line.P1.AngleYZ+Degree) Mod 360)
		NLine.P1.z=Line.P1.RadialYZ*CosD((360+Line.P1.AngleyZ+Degree) Mod 360)
		NLine.P1.Color=Line.P1.Color
		NLine.P2.X=Line.P2.X
		NLine.P2.y=Line.P2.RadialYZ*SinD((360+Line.P2.AngleYZ+Degree) Mod 360)
		NLine.P2.z=Line.P2.RadialYZ*CosD((360+Line.P2.AngleYZ+Degree) Mod 360)
		NLine.P2.Color=Line.P2.Color
		
		NewLine3d.AddLine2(NLine)
	Next
	'Polygon
	For i=0 To PolygonList.Size-1
		Dim Pol As T_Point = PolygonList.Get(I)
		NewLine3d.AddPolygon(Pol.ID,Pol.X,Pol.RadialYZ*SinD((360+Pol.ANgleYZ+Degree) Mod 360),Pol.RadialYZ*CosD((360+Pol.ANgleYZ+Degree) Mod 360),Pol.Color)
	Next
	' Image
	For i=0 To ImageList.Size-1
		Dim Im As T_Image = ImageList.Get(I)
		Dim P_TopLeft,P_TopRight,P_DownLeft,P_DownRight As T_Point
						
		P_TopLeft=CoordinateToPoint(-1,Im.P_TopLeft.x,Im.P_TopLeft.RadialYZ*SinD((360+Im.P_TopLeft.ANgleYZ+Degree) Mod 360),Im.P_TopLeft.RadialYZ*CosD((360+Im.P_TopLeft.ANgleYZ+Degree) Mod 360),0)
		P_TopRight=CoordinateToPoint(-1,Im.P_TopRight.X,Im.P_TopRight.RadialYZ*SinD((360+Im.P_TopRight.ANgleYZ+Degree) Mod 360),Im.P_TopRight.RadialYZ*CosD((360+Im.P_TopRight.ANgleYZ+Degree) Mod 360),0)
		P_DownLeft=CoordinateToPoint(-1,Im.P_DownLeft.X,Im.P_DownLeft.RadialYZ*SinD((360+Im.P_DownLeft.ANgleYZ+Degree) Mod 360),Im.P_DownLeft.RadialYZ*CosD((360+Im.P_DownLeft.ANgleYZ+Degree) Mod 360),0)
		P_DownRight=CoordinateToPoint(-1,Im.P_DownRight.X,Im.P_DownRight.RadialYZ*SinD((360+Im.P_DownRight.ANgleYZ+Degree) Mod 360),Im.P_DownRight.RadialYZ*CosD((360+Im.P_DownRight.ANgleYZ+Degree) Mod 360),0)
		NewLine3d.AddImage(Im.BitmapCreator.Bitmap,P_TopLeft,P_TopRight,P_DownLeft,P_DownRight)
	Next
	
	Return NewLine3d
End Sub

#end region


Private Sub Trapezio(bmp As BitmapCreator,Can As B4XCanvas, CenterX As Int, CenterY As Int,p1 As T_Point, p2 As T_Point, p3 As T_Point, p4 As T_Point ) 'As B4XBitmap
	' WE ARE SORRY BUT THIS IS A SECRET
End Sub
